# /etc/nginx/nginx.conf

user nginx;

# Set number of worker processes automatically based on number of CPU cores.
worker_processes {{ getenv "NGINX_WORKER_PROCESSES" }};

# Enables the use of JIT for regular expressions to speed-up their processing.
pcre_jit on;

# Configures default error logger.
error_log /dev/stderr {{ getenv "NGINX_ERROR_LOG_LEVEL" }};

# Includes files with directives to load dynamic modules.
include /etc/nginx/modules/*.conf;


events {
        # The maximum number of simultaneous connections that can be opened by
        # a worker process.
        worker_connections {{ getenv "NGINX_WORKER_CONNECTIONS" }};
}

http {
        # Includes mapping of file name extensions to MIME types of responses
        # and defines the default type.
        include /etc/nginx/mime.types;
        default_type application/octet-stream;

        # Name servers used to resolve names of upstream servers into addresses.
        # It's also needed when using tcpsocket and udpsocket in Lua modules.
        #resolver 1.1.1.1 1.0.0.1 2606:4700:4700::1111 2606:4700:4700::1001;

        # Don't tell nginx version to the clients. Default is 'on'.
        server_tokens off;

        # Specifies the maximum accepted body size of a client request, as
        # indicated by the request header Content-Length. If the stated content
        # length is greater than this size, then the client receives the HTTP
        # error code 413. Set to 0 to disable. Default is '1m'.
        client_max_body_size {{ getenv "NGINX_CLIENT_MAX_BODY_SIZE" }};

        # Defines a timeout for reading client request body. The timeout is
        # set only for a period between two successive read operations, not for
        # the transmission of the whole request body. If a client does not
        # transmit anything within this time, the request is terminated with the
        # 408 (Request Time-out) error.
        client_body_timeout {{ getenv "NGINX_CLIENT_BODY_TIMEOUT" }};

        # Sets a timeout for transmitting a response to the client. The timeout
        # is set only between two successive write operations, not for the
        # transmission of the whole response. If the client does not receive
        # anything within this time, the connection is closed.
        send_timeout {{ getenv "NGINX_SEND_TIMEOUT" }};

        # The first parameter sets a timeout during which a keep-alive client
        # connection will stay open on the server side. The zero value disables
        # keep-alive client connections. The optional second parameter sets a
        # value in the “Keep-Alive: timeout=time” response header field. Two
        # parameters may differ.
        keepalive_timeout {{ getenv "NGINX_KEEPALIVE_TIMEOUT" }};

        # When lingering_close is in effect, this directive specifies the maximum
        # waiting time for more client data to arrive. If data are not received
        # during this time, the connection is closed. Otherwise, the data are
        # read and ignored, and nginx starts waiting for more data again. The
        # “wait-read-ignore” cycle is repeated, but no longer than specified by
        # the lingering_time directive.
        lingering_timeout {{ getenv "NGINX_LINGERING_TIMEOUT" }};

        # Sendfile copies data between one FD and other from within the kernel,
        # which is more efficient than read() + write(). Default is off.
        sendfile on;

        # Causes nginx to attempt to send its HTTP response head in one packet,
        # instead of using partial frames. Default is 'off'.
        tcp_nopush on;

        # Enables the specified protocols. Default is TLSv1 TLSv1.1 TLSv1.2.
        # TIP: If you're not obligated to support ancient clients, remove TLSv1.1.
        ssl_protocols TLSv1.1 TLSv1.2 TLSv1.3;

        # Path of the file with Diffie-Hellman parameters for EDH ciphers.
        # TIP: Generate with: `openssl dhparam -out /etc/ssl/nginx/dh2048.pem 2048`
        #ssl_dhparam /etc/ssl/nginx/dh2048.pem;

        # Specifies that our cipher suits should be preferred over client ciphers.
        # Default is 'off'.
        ssl_prefer_server_ciphers on;

        # Enables a shared SSL cache with size that can hold around 8000 sessions.
        # Default is 'none'.
        ssl_session_cache shared:SSL:2m;

        # Specifies a time during which a client may reuse the session parameters.
        # Default is '5m'.
        ssl_session_timeout 1h;

        # Disable TLS session tickets (they are insecure). Default is 'on'.
        ssl_session_tickets off;

        # Enable gzipping of responses.
        #gzip on;

        # Set the Vary HTTP header as defined in the RFC 2616. Default is 'off'.
        gzip_vary on;

        # Defines a timeout for establishing a connection with a FastCGI server.
        # It should be noted that this timeout cannot usually exceed 75 seconds.
        fastcgi_connect_timeout {{ getenv "NGINX_FASTCGI_CONNECT_TIMEOUT" }};

        # Defines a timeout for reading a response from the FastCGI server. The
        # timeout is set only between two successive read operations, not for the
        # transmission of the whole response. If the FastCGI server does not
        # transmit anything within this time, the connection is closed.
        fastcgi_read_timeout {{ getenv "NGINX_FASTCGI_READ_TIMEOUT" }};

        # Sets a timeout for transmitting a request to the FastCGI server. The
        # timeout is set only between two successive write operations, not for
        # the transmission of the whole request. If the FastCGI server does not
        # receive anything within this time, the connection is closed.
        fastcgi_send_timeout {{ getenv "NGINX_FASTCGI_SEND_TIMEOUT" }};

        # Defines a timeout for establishing a connection with a proxied server.
        # It should be noted that this timeout cannot usually exceed 75 seconds.
        proxy_connect_timeout {{ getenv "NGINX_PROXY_CONNECT_TIMEOUT" }};

        # Defines a timeout for reading a response from the proxied server. The
        # timeout is set only between two successive read operations, not for the
        # transmission of the whole response. If the proxied server does not
        # transmit anything within this time, the connection is closed.
        proxy_read_timeout {{ getenv "NGINX_PROXY_READ_TIMEOUT" }};


        # Sets a timeout for transmitting a request to the proxied server. The
        # timeout is set only between two successive write operations, not for
        # the transmission of the whole request. If the proxied server does not
        # receive anything within this time, the connection is closed.
        proxy_send_timeout {{ getenv "NGINX_PROXY_SEND_TIMEOUT" }};

        # Helper variable for proxying websockets.
        map $http_upgrade $connection_upgrade {
                default upgrade;
                '' close;
        }


        # Specifies the main log format.
        log_format main '$remote_addr - $remote_user [$time_local] "$request" '
                        '$status $body_bytes_sent "$http_referer" '
                        '"$http_user_agent" "$http_x_forwarded_for"';

        # Sets the path, format, and configuration for a buffered log write.
        access_log /dev/stdout main;

        # Includes virtual hosts configs.
        include /etc/nginx/sites-enabled/*;

        # WARNING: Don't use this directory for virtual hosts anymore.
        # This include will be moved to the root context in Alpine 3.14.
        #include /etc/nginx/conf.d/*.conf;
}

# TIP: Uncomment if you use stream module.
#include /etc/nginx/stream.conf;
